/* Driver template for the LEMON parser generator.
** The author disclaims copyright to this source code.
*/
/* First off, code is include which follows the "include" declaration
** in the input file. */
#include <stdio.h>
#line 16 "src/parser.y"

#include <apr_strings.h>

#include "parser.h"
#include "common.h"
#include "lexer.h"
#line 16 "src/parser.c"
/* Next is all token values, in a form suitable for use by makeheaders.
** This section will be null unless lemon is run with the -m switch.
*/
/* 
** These constants (all generated automatically by the parser generator)
** specify the various kinds of tokens (terminals) that the parser
** understands. 
**
** Each symbol here is a terminal symbol in the grammar.
*/
/* Make sure the INTERFACE macro is defined.
*/
#ifndef INTERFACE
# define INTERFACE 1
#endif
/* The next thing included is series of defines which control
** various aspects of the generated parser.
**    YYCODETYPE         is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 terminals
**                       and nonterminals.  "int" is used otherwise.
**    YYNOCODE           is a number of type YYCODETYPE which corresponds
**                       to no legal terminal or nonterminal number.  This
**                       number is used to fill in empty slots of the hash 
**                       table.
**    YYFALLBACK         If defined, this indicates that one or more tokens
**                       have fall-back values which should be used if the
**                       original value of the token will not parse.
**    YYACTIONTYPE       is the data type used for storing terminal
**                       and nonterminal numbers.  "unsigned char" is
**                       used if there are fewer than 250 rules and
**                       states combined.  "int" is used otherwise.
**    etl_parser_parseTOKENTYPE     is the data type used for minor tokens given 
**                       directly to the parser from the tokenizer.
**    YYMINORTYPE        is the data type used for all minor tokens.
**                       This is typically a union of many types, one of
**                       which is etl_parser_parseTOKENTYPE.  The entry in the union
**                       for base tokens is called "yy0".
**    YYSTACKDEPTH       is the maximum depth of the parser's stack.
**    etl_parser_parseARG_SDECL     A static variable declaration for the %extra_argument
**    etl_parser_parseARG_PDECL     A parameter declaration for the %extra_argument
**    etl_parser_parseARG_STORE     Code to store %extra_argument into yypParser
**    etl_parser_parseARG_FETCH     Code to extract %extra_argument from yypParser
**    YYNSTATE           the combined number of states.
**    YYNRULE            the number of rules in the grammar
**    YYERRORSYMBOL      is the code number of the error symbol.  If not
**                       defined, then do no error processing.
*/
#define YYCODETYPE unsigned char
#define YYNOCODE 23
#define YYACTIONTYPE unsigned char
#define etl_parser_parseTOKENTYPE  char * 
typedef union {
  etl_parser_parseTOKENTYPE yy0;
  etl_for_contents_t * yy2;
  etl_if_contents_t * yy22;
  etl_template_t * yy34;
  etl_template_node_t * yy35;
  int yy45;
} YYMINORTYPE;
#define YYSTACKDEPTH 100
#define etl_parser_parseARG_SDECL  etl_parser_state_t *state ;
#define etl_parser_parseARG_PDECL , etl_parser_state_t *state 
#define etl_parser_parseARG_FETCH  etl_parser_state_t *state  = yypParser->state 
#define etl_parser_parseARG_STORE yypParser->state  = state 
#define YYNSTATE 44
#define YYNRULE 16
#define YYERRORSYMBOL 13
#define YYERRSYMDT yy45
#define YY_NO_ACTION      (YYNSTATE+YYNRULE+2)
#define YY_ACCEPT_ACTION  (YYNSTATE+YYNRULE+1)
#define YY_ERROR_ACTION   (YYNSTATE+YYNRULE)

/* Next are that tables used to determine what action to take based on the
** current state and lookahead token.  These tables are used to implement
** functions that take a state number and lookahead value and return an
** action integer.  
**
** Suppose the action integer is N.  Then the action is determined as
** follows
**
**   0 <= N < YYNSTATE                  Shift N.  That is, push the lookahead
**                                      token onto the stack and goto state N.
**
**   YYNSTATE <= N < YYNSTATE+YYNRULE   Reduce by rule N-YYNSTATE.
**
**   N == YYNSTATE+YYNRULE              A syntax error has occurred.
**
**   N == YYNSTATE+YYNRULE+1            The parser accepts its input.
**
**   N == YYNSTATE+YYNRULE+2            No such action.  Denotes unused
**                                      slots in the yy_action[] table.
**
** The action table is constructed as a single large table named yy_action[].
** Given state S and lookahead X, the action is computed as
**
**      yy_action[ yy_shift_ofst[S] + X ]
**
** If the index value yy_shift_ofst[S]+X is out of range or if the value
** yy_lookahead[yy_shift_ofst[S]+X] is not equal to X or if yy_shift_ofst[S]
** is equal to YY_SHIFT_USE_DFLT, it means that the action is not in the table
** and that yy_default[S] should be used instead.  
**
** The formula above is for computing the action when the lookahead is
** a terminal symbol.  If the lookahead is a non-terminal (as occurs after
** a reduce action) then the yy_reduce_ofst[] array is used in place of
** the yy_shift_ofst[] array and YY_REDUCE_USE_DFLT is used in place of
** YY_SHIFT_USE_DFLT.
**
** The following are the tables generated in this section:
**
**  yy_action[]        A single table containing all actions.
**  yy_lookahead[]     A table containing the lookahead for each entry in
**                     yy_action.  Used to detect hash collisions.
**  yy_shift_ofst[]    For each state, the offset into yy_action for
**                     shifting terminals.
**  yy_reduce_ofst[]   For each state, the offset into yy_action for
**                     shifting non-terminals after a reduce.
**  yy_default[]       Default action for each state.
*/
static const YYACTIONTYPE yy_action[] = {
 /*     0 */    40,    1,   22,   30,   37,   61,    2,    6,   22,   30,
 /*    10 */    37,    7,   29,   41,    5,    3,    4,    8,   25,   11,
 /*    20 */     9,   27,   16,    2,   18,   22,   30,   37,   12,   32,
 /*    30 */    33,   19,   40,   23,   22,   30,   37,   40,   31,   22,
 /*    40 */    30,   37,   40,   34,   22,   30,   37,    2,   10,   22,
 /*    50 */    30,   37,   14,   36,    5,    5,   13,    8,    8,   11,
 /*    60 */    11,   27,   16,   16,   40,   38,   22,   30,   37,    2,
 /*    70 */    15,   22,   30,   37,   17,   39,   40,   42,   22,   30,
 /*    80 */    37,    2,   20,   22,   30,   37,    2,   43,   22,   30,
 /*    90 */    37,   44,    3,    4,    3,   24,    3,   35,   40,   21,
 /*   100 */    40,   26,   28,
};
static const YYCODETYPE yy_lookahead[] = {
 /*     0 */    14,   15,   16,   17,   18,   19,   14,    4,   16,   17,
 /*    10 */    18,    5,   20,   21,    3,    1,    2,    6,    7,    8,
 /*    20 */     4,   10,   11,   14,    5,   16,   17,   18,    4,   20,
 /*    30 */    21,   12,   14,   15,   16,   17,   18,   14,   15,   16,
 /*    40 */    17,   18,   14,   15,   16,   17,   18,   14,    5,   16,
 /*    50 */    17,   18,    4,   20,    3,    3,    9,    6,    6,    8,
 /*    60 */     8,   10,   11,   11,   14,   15,   16,   17,   18,   14,
 /*    70 */     5,   16,   17,   18,    4,   20,   14,   15,   16,   17,
 /*    80 */    18,   14,    4,   16,   17,   18,   14,   20,   16,   17,
 /*    90 */    18,    0,    1,    2,    1,    2,    1,    2,   22,    5,
 /*   100 */    22,    5,    5,
};
#define YY_SHIFT_USE_DFLT (-1)
static const signed char yy_shift_ofst[] = {
 /*     0 */    14,   91,   -1,   -1,   52,    3,    6,   -1,   16,   43,
 /*    10 */    -1,   24,   47,   48,   65,   -1,   70,   19,   -1,   78,
 /*    20 */    94,   -1,   14,   93,   11,   96,   -1,   97,   -1,   -1,
 /*    30 */    14,   93,   -1,   14,   95,   51,   -1,   14,   95,   -1,
 /*    40 */    -1,   14,   95,   -1,
};
#define YY_REDUCE_USE_DFLT (-15)
static const signed char yy_reduce_ofst[] = {
 /*     0 */   -14,   72,  -15,  -15,  -15,  -15,  -15,  -15,  -15,  -15,
 /*    10 */   -15,  -15,  -15,  -15,  -15,  -15,  -15,  -15,  -15,  -15,
 /*    20 */   -15,  -15,   18,   -8,  -15,  -15,  -15,  -15,  -15,  -15,
 /*    30 */    23,    9,  -15,   28,   33,  -15,  -15,   50,   55,  -15,
 /*    40 */   -15,   62,   67,  -15,
};
static const YYACTIONTYPE yy_default[] = {
 /*     0 */    60,   60,   45,   47,   60,   60,   60,   48,   60,   60,
 /*    10 */    49,   60,   60,   60,   60,   55,   60,   60,   58,   60,
 /*    20 */    60,   59,   60,   60,   60,   60,   52,   60,   56,   50,
 /*    30 */    60,   60,   51,   60,   60,   60,   54,   60,   60,   57,
 /*    40 */    46,   60,   60,   53,
};
#define YY_SZ_ACTTAB (sizeof(yy_action)/sizeof(yy_action[0]))

/* The next table maps tokens into fallback tokens.  If a construct
** like the following:
** 
**      %fallback ID X Y Z.
**
** appears in the grammer, then ID becomes a fallback token for X, Y,
** and Z.  Whenever one of the tokens X, Y, or Z is input to the parser
** but it does not parse, the type of the token is changed to ID and
** the parse is retried before an error is thrown.
*/
#ifdef YYFALLBACK
static const YYCODETYPE yyFallback[] = {
};
#endif /* YYFALLBACK */

/* The following structure represents a single element of the
** parser's stack.  Information stored includes:
**
**   +  The state number for the parser at this level of the stack.
**
**   +  The value of the token stored at this level of the stack.
**      (In other words, the "major" token.)
**
**   +  The semantic value stored at this level of the stack.  This is
**      the information used by the action routines in the grammar.
**      It is sometimes called the "minor" token.
*/
struct yyStackEntry {
  int stateno;       /* The state-number */
  int major;         /* The major token value.  This is the code
                     ** number for the token at this stack level */
  YYMINORTYPE minor; /* The user-supplied minor token value.  This
                     ** is the value of the token  */
};
typedef struct yyStackEntry yyStackEntry;

/* The state of the parser is completely contained in an instance of
** the following structure */
struct yyParser {
  int yyidx;                    /* Index of top element in stack */
  int yyerrcnt;                 /* Shifts left before out of the error */
  etl_parser_parseARG_SDECL                /* A place to hold %extra_argument */
  yyStackEntry yystack[YYSTACKDEPTH];  /* The parser's stack */
};
typedef struct yyParser yyParser;

#ifndef NDEBUG
#include <stdio.h>
static FILE *yyTraceFILE = 0;
static char *yyTracePrompt = 0;
#endif /* NDEBUG */

#ifndef NDEBUG
/* 
** Turn parser tracing on by giving a stream to which to write the trace
** and a prompt to preface each trace message.  Tracing is turned off
** by making either argument NULL 
**
** Inputs:
** <ul>
** <li> A FILE* to which trace output should be written.
**      If NULL, then tracing is turned off.
** <li> A prefix string written at the beginning of every
**      line of trace output.  If NULL, then tracing is
**      turned off.
** </ul>
**
** Outputs:
** None.
*/
void etl_parser_parseTrace(FILE *TraceFILE, char *zTracePrompt){
  yyTraceFILE = TraceFILE;
  yyTracePrompt = zTracePrompt;
  if( yyTraceFILE==0 ) yyTracePrompt = 0;
  else if( yyTracePrompt==0 ) yyTraceFILE = 0;
}
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing shifts, the names of all terminals and nonterminals
** are required.  The following table supplies these names */
static const char *const yyTokenName[] = { 
  "$",             "TEXT",          "START_DIR",     "IF",          
  "VAR",           "END_DIR",       "UNLESS",        "ELSE",        
  "FOR",           "IN",            "END",           "PRINT",       
  "PIPE",          "error",         "expression",    "expression_list",
  "if",            "unless",        "for",           "template",    
  "end",           "else",        
};
#endif /* NDEBUG */

#ifndef NDEBUG
/* For tracing reduce actions, the names of all rules are required.
*/
static const char *const yyRuleName[] = {
 /*   0 */ "template ::= expression_list",
 /*   1 */ "expression_list ::= expression_list expression",
 /*   2 */ "expression_list ::= expression",
 /*   3 */ "expression ::= TEXT",
 /*   4 */ "if ::= START_DIR IF VAR END_DIR",
 /*   5 */ "unless ::= START_DIR UNLESS VAR END_DIR",
 /*   6 */ "expression ::= if expression_list end",
 /*   7 */ "expression ::= unless expression_list end",
 /*   8 */ "else ::= START_DIR ELSE END_DIR",
 /*   9 */ "expression ::= if expression_list else expression_list end",
 /*  10 */ "expression ::= unless expression_list else expression_list end",
 /*  11 */ "for ::= START_DIR FOR VAR IN VAR END_DIR",
 /*  12 */ "end ::= START_DIR END END_DIR",
 /*  13 */ "expression ::= for expression_list end",
 /*  14 */ "expression ::= START_DIR PRINT VAR END_DIR",
 /*  15 */ "expression ::= START_DIR PRINT VAR PIPE VAR END_DIR",
};
#endif /* NDEBUG */

/*
** This function returns the symbolic name associated with a token
** value.
*/
const char *etl_parser_parseTokenName(int tokenType){
#ifndef NDEBUG
  if( tokenType>0 && tokenType<(sizeof(yyTokenName)/sizeof(yyTokenName[0])) ){
    return yyTokenName[tokenType];
  }else{
    return "Unknown";
  }
#else
  return "";
#endif
}

/* 
** This function allocates a new parser.
** The only argument is a pointer to a function which works like
** malloc.
**
** Inputs:
** A pointer to the function used to allocate memory.
**
** Outputs:
** A pointer to a parser.  This pointer is used in subsequent calls
** to etl_parser_parse and etl_parser_parseFree.
*/
void *etl_parser_parseAlloc(void *(*mallocProc)(size_t)){
  yyParser *pParser;
  pParser = (yyParser*)(*mallocProc)( (size_t)sizeof(yyParser) );
  if( pParser ){
    pParser->yyidx = -1;
  }
  return pParser;
}

/* The following function deletes the value associated with a
** symbol.  The symbol can be either a terminal or nonterminal.
** "yymajor" is the symbol code, and "yypminor" is a pointer to
** the value.
*/
static void yy_destructor(YYCODETYPE yymajor, YYMINORTYPE *yypminor){
  switch( yymajor ){
    /* Here is inserted the actions which take place when a
    ** terminal or non-terminal is destroyed.  This can happen
    ** when the symbol is popped from the stack during a
    ** reduce or during error processing or when a parser is 
    ** being destroyed before it is finished parsing.
    **
    ** Note: during a reduce, the only symbols destroyed are those
    ** which appear on the RHS of the rule, but which are not used
    ** inside the C code.
    */
    default:  break;   /* If no destructor action specified: do nothing */
  }
}

/*
** Pop the parser's stack once.
**
** If there is a destructor routine associated with the token which
** is popped from the stack, then call it.
**
** Return the major token number for the symbol popped.
*/
static int yy_pop_parser_stack(yyParser *pParser){
  YYCODETYPE yymajor;
  yyStackEntry *yytos = &pParser->yystack[pParser->yyidx];

  if( pParser->yyidx<0 ) return 0;
#ifndef NDEBUG
  if( yyTraceFILE && pParser->yyidx>=0 ){
    fprintf(yyTraceFILE,"%sPopping %s\n",
      yyTracePrompt,
      yyTokenName[yytos->major]);
  }
#endif
  yymajor = yytos->major;
  yy_destructor( yymajor, &yytos->minor);
  pParser->yyidx--;
  return yymajor;
}

/* 
** Deallocate and destroy a parser.  Destructors are all called for
** all stack elements before shutting the parser down.
**
** Inputs:
** <ul>
** <li>  A pointer to the parser.  This should be a pointer
**       obtained from etl_parser_parseAlloc.
** <li>  A pointer to a function used to reclaim memory obtained
**       from malloc.
** </ul>
*/
void etl_parser_parseFree(
  void *p,                    /* The parser to be deleted */
  void (*freeProc)(void*)     /* Function used to reclaim memory */
){
  yyParser *pParser = (yyParser*)p;
  if( pParser==0 ) return;
  while( pParser->yyidx>=0 ) yy_pop_parser_stack(pParser);
  (*freeProc)((void*)pParser);
}

/*
** Find the appropriate action for a parser given the terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_shift_action(
  yyParser *pParser,        /* The parser */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  int stateno = pParser->yystack[pParser->yyidx].stateno;
 
  /* if( pParser->yyidx<0 ) return YY_NO_ACTION;  */
  i = yy_shift_ofst[stateno];
  if( i==YY_SHIFT_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
#ifdef YYFALLBACK
    int iFallback;            /* Fallback token */
    if( iLookAhead<sizeof(yyFallback)/sizeof(yyFallback[0])
           && (iFallback = yyFallback[iLookAhead])!=0 ){
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE, "%sFALLBACK %s => %s\n",
           yyTracePrompt, yyTokenName[iLookAhead], yyTokenName[iFallback]);
      }
#endif
      return yy_find_shift_action(pParser, iFallback);
    }
#endif
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Find the appropriate action for a parser given the non-terminal
** look-ahead token iLookAhead.
**
** If the look-ahead token is YYNOCODE, then check to see if the action is
** independent of the look-ahead.  If it is, return the action, otherwise
** return YY_NO_ACTION.
*/
static int yy_find_reduce_action(
  int stateno,              /* Current state number */
  int iLookAhead            /* The look-ahead token */
){
  int i;
  /* int stateno = pParser->yystack[pParser->yyidx].stateno; */
 
  i = yy_reduce_ofst[stateno];
  if( i==YY_REDUCE_USE_DFLT ){
    return yy_default[stateno];
  }
  if( iLookAhead==YYNOCODE ){
    return YY_NO_ACTION;
  }
  i += iLookAhead;
  if( i<0 || i>=YY_SZ_ACTTAB || yy_lookahead[i]!=iLookAhead ){
    return yy_default[stateno];
  }else{
    return yy_action[i];
  }
}

/*
** Perform a shift action.
*/
static void yy_shift(
  yyParser *yypParser,          /* The parser to be shifted */
  int yyNewState,               /* The new state to shift in */
  int yyMajor,                  /* The major token to shift in */
  YYMINORTYPE *yypMinor         /* Pointer ot the minor token to shift in */
){
  yyStackEntry *yytos;
  yypParser->yyidx++;
  if( yypParser->yyidx>=YYSTACKDEPTH ){
     etl_parser_parseARG_FETCH;
     yypParser->yyidx--;
#ifndef NDEBUG
     if( yyTraceFILE ){
       fprintf(yyTraceFILE,"%sStack Overflow!\n",yyTracePrompt);
     }
#endif
     while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
     /* Here code is inserted which will execute if the parser
     ** stack every overflows */
     etl_parser_parseARG_STORE; /* Suppress warning about unused %extra_argument var */
     return;
  }
  yytos = &yypParser->yystack[yypParser->yyidx];
  yytos->stateno = yyNewState;
  yytos->major = yyMajor;
  yytos->minor = *yypMinor;
#ifndef NDEBUG
  if( yyTraceFILE && yypParser->yyidx>0 ){
    int i;
    fprintf(yyTraceFILE,"%sShift %d\n",yyTracePrompt,yyNewState);
    fprintf(yyTraceFILE,"%sStack:",yyTracePrompt);
    for(i=1; i<=yypParser->yyidx; i++)
      fprintf(yyTraceFILE," %s",yyTokenName[yypParser->yystack[i].major]);
    fprintf(yyTraceFILE,"\n");
  }
#endif
}

/* The following table contains information about every rule that
** is used during the reduce.
*/
static const struct {
  YYCODETYPE lhs;         /* Symbol on the left-hand side of the rule */
  unsigned char nrhs;     /* Number of right-hand side symbols in the rule */
} yyRuleInfo[] = {
  { 19, 1 },
  { 15, 2 },
  { 15, 1 },
  { 14, 1 },
  { 16, 4 },
  { 17, 4 },
  { 14, 3 },
  { 14, 3 },
  { 21, 3 },
  { 14, 5 },
  { 14, 5 },
  { 18, 6 },
  { 20, 3 },
  { 14, 3 },
  { 14, 4 },
  { 14, 6 },
};

static void yy_accept(yyParser*);  /* Forward Declaration */

/*
** Perform a reduce action and the shift that must immediately
** follow the reduce.
*/
static void yy_reduce(
  yyParser *yypParser,         /* The parser */
  int yyruleno                 /* Number of the rule by which to reduce */
){
  int yygoto;                     /* The next state */
  int yyact;                      /* The next action */
  YYMINORTYPE yygotominor;        /* The LHS of the rule reduced */
  yyStackEntry *yymsp;            /* The top of the parser's stack */
  int yysize;                     /* Amount to pop the stack */
  etl_parser_parseARG_FETCH;
  yymsp = &yypParser->yystack[yypParser->yyidx];
#ifndef NDEBUG
  if( yyTraceFILE && yyruleno>=0 
        && yyruleno<sizeof(yyRuleName)/sizeof(yyRuleName[0]) ){
    fprintf(yyTraceFILE, "%sReduce [%s].\n", yyTracePrompt,
      yyRuleName[yyruleno]);
  }
#endif /* NDEBUG */

#ifndef NDEBUG
  /* Silence complaints from purify about yygotominor being uninitialized
  ** in some cases when it is copied into the stack after the following
  ** switch.  yygotominor is uninitialized when a rule reduces that does
  ** not set the value of its left-hand side nonterminal.  Leaving the
  ** value of the nonterminal uninitialized is utterly harmless as long
  ** as the value is never used.  So really the only thing this code
  ** accomplishes is to quieten purify.  
  */
  memset(&yygotominor, 0, sizeof(yygotominor));
#endif

  switch( yyruleno ){
  /* Beginning here are the reduction cases.  A typical example
  ** follows:
  **   case 0:
  **  #line <lineno> <grammarfile>
  **     { ... }           // User supplied code
  **  #line <lineno> <thisfile>
  **     break;
  */
      case 0:
#line 40 "src/parser.y"
{
    if (! state->error)
      {
        state->tmpl = apr_pcalloc (state->pool, sizeof (*state->tmpl));
        state->tmpl->tree = yymsp[0].minor.yy35;
      }
  }
#line 603 "src/parser.c"
        break;
      case 1:
#line 49 "src/parser.y"
{
    etl_template_node_t *itr = yymsp[-1].minor.yy35;

    while (itr->next != NULL)
      itr = itr->next;

    itr->next = yymsp[0].minor.yy35;

    yygotominor.yy35 = yymsp[-1].minor.yy35;
  }
#line 617 "src/parser.c"
        break;
      case 2:
#line 61 "src/parser.y"
{
    yygotominor.yy35 = yymsp[0].minor.yy35;
  }
#line 624 "src/parser.c"
        break;
      case 3:
#line 66 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_LITERAL;
    yygotominor.yy35->contents.l.data = yymsp[0].minor.yy0;
    yygotominor.yy35->next = NULL;
  }
#line 634 "src/parser.c"
        break;
      case 4:
      case 5:
#line 74 "src/parser.y"
{
    yygotominor.yy22 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy22));
    yygotominor.yy22->var = yymsp[-1].minor.yy0;
  }
#line 643 "src/parser.c"
        break;
      case 6:
#line 86 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_IF;
    yymsp[-2].minor.yy22->yes_task = yymsp[-1].minor.yy35;
    yymsp[-2].minor.yy22->no_task = NULL;
    yygotominor.yy35->contents.i = yymsp[-2].minor.yy22;
    yygotominor.yy35->next = NULL;
  }
#line 655 "src/parser.c"
        break;
      case 7:
#line 96 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_UNLESS;
    yymsp[-2].minor.yy22->yes_task = yymsp[-1].minor.yy35;
    yymsp[-2].minor.yy22->no_task = NULL;
    yygotominor.yy35->contents.i = yymsp[-2].minor.yy22;
    yygotominor.yy35->next = NULL;
  }
#line 667 "src/parser.c"
        break;
      case 9:
#line 108 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_IF;
    yymsp[-4].minor.yy22->yes_task = yymsp[-3].minor.yy35;
    yymsp[-4].minor.yy22->no_task = yymsp[-1].minor.yy35;
    yygotominor.yy35->contents.i = yymsp[-4].minor.yy22;
    yygotominor.yy35->next = NULL;
  }
#line 679 "src/parser.c"
        break;
      case 10:
#line 118 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_UNLESS;
    yymsp[-4].minor.yy22->yes_task = yymsp[-3].minor.yy35;
    yymsp[-4].minor.yy22->no_task = yymsp[-1].minor.yy35;
    yygotominor.yy35->contents.i = yymsp[-4].minor.yy22;
    yygotominor.yy35->next = NULL;
  }
#line 691 "src/parser.c"
        break;
      case 11:
#line 129 "src/parser.y"
{
    yygotominor.yy2 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy2));
    yygotominor.yy2->var = yymsp[-3].minor.yy0;
    yygotominor.yy2->arr = yymsp[-1].minor.yy0;
  }
#line 700 "src/parser.c"
        break;
      case 13:
#line 138 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_FOR;
    yymsp[-2].minor.yy2->task = yymsp[-1].minor.yy35;
    yygotominor.yy35->contents.f = yymsp[-2].minor.yy2;
    yygotominor.yy35->next = NULL;
  }
#line 711 "src/parser.c"
        break;
      case 14:
#line 147 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_PRINT;
    yygotominor.yy35->contents.p.var = yymsp[-1].minor.yy0;
    yygotominor.yy35->next = NULL;
  }
#line 721 "src/parser.c"
        break;
      case 15:
#line 155 "src/parser.y"
{
    yygotominor.yy35 = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35));
    yygotominor.yy35->type = ETL_NODE_FILTER;
    yygotominor.yy35->contents.flt = apr_pcalloc (state->pool, sizeof (*yygotominor.yy35->contents.flt));
    yygotominor.yy35->contents.flt->var = yymsp[-3].minor.yy0;

    if (strcmp (yymsp[-1].minor.yy0, "html") == 0)
      yygotominor.yy35->contents.flt->filter = etl_template_filter_html;
    else if (strcmp (yymsp[-1].minor.yy0, "xml") == 0)
      yygotominor.yy35->contents.flt->filter = etl_template_filter_xml;
    else if (strcmp (yymsp[-1].minor.yy0, "url") == 0)
      yygotominor.yy35->contents.flt->filter = etl_template_filter_url;
    else
      state->error = apr_psprintf (state->pool, "unknown filter '%s'", yymsp[-1].minor.yy0);

    yygotominor.yy35->next = NULL;
  }
#line 742 "src/parser.c"
        break;
  };
  yygoto = yyRuleInfo[yyruleno].lhs;
  yysize = yyRuleInfo[yyruleno].nrhs;
  yypParser->yyidx -= yysize;
  yyact = yy_find_reduce_action(yymsp[-yysize].stateno,yygoto);
  if( yyact < YYNSTATE ){
#ifdef NDEBUG
    /* If we are not debugging and the reduce action popped at least
    ** one element off the stack, then we can push the new element back
    ** onto the stack here, and skip the stack overflow test in yy_shift().
    ** That gives a significant speed improvement. */
    if( yysize ){
      yypParser->yyidx++;
      yymsp -= yysize-1;
      yymsp->stateno = yyact;
      yymsp->major = yygoto;
      yymsp->minor = yygotominor;
    }else
#endif
    {
      yy_shift(yypParser,yyact,yygoto,&yygotominor);
    }
  }else if( yyact == YYNSTATE + YYNRULE + 1 ){
    yy_accept(yypParser);
  }
}

/*
** The following code executes when the parse fails
*/
static void yy_parse_failed(
  yyParser *yypParser           /* The parser */
){
  etl_parser_parseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sFail!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser fails */
  etl_parser_parseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following code executes when a syntax error first occurs.
*/
static void yy_syntax_error(
  yyParser *yypParser,           /* The parser */
  int yymajor,                   /* The major type of the error token */
  YYMINORTYPE yyminor            /* The minor type of the error token */
){
  etl_parser_parseARG_FETCH;
#define TOKEN (yyminor.yy0)
  etl_parser_parseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/*
** The following is executed when the parser accepts
*/
static void yy_accept(
  yyParser *yypParser           /* The parser */
){
  etl_parser_parseARG_FETCH;
#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sAccept!\n",yyTracePrompt);
  }
#endif
  while( yypParser->yyidx>=0 ) yy_pop_parser_stack(yypParser);
  /* Here code is inserted which will be executed whenever the
  ** parser accepts */
  etl_parser_parseARG_STORE; /* Suppress warning about unused %extra_argument variable */
}

/* The main parser program.
** The first argument is a pointer to a structure obtained from
** "etl_parser_parseAlloc" which describes the current state of the parser.
** The second argument is the major token number.  The third is
** the minor token.  The fourth optional argument is whatever the
** user wants (and specified in the grammar) and is available for
** use by the action routines.
**
** Inputs:
** <ul>
** <li> A pointer to the parser (an opaque structure.)
** <li> The major token number.
** <li> The minor token number.
** <li> An option argument of a grammar-specified type.
** </ul>
**
** Outputs:
** None.
*/
void etl_parser_parse(
  void *yyp,                   /* The parser */
  int yymajor,                 /* The major token code number */
  etl_parser_parseTOKENTYPE yyminor       /* The value for the token */
  etl_parser_parseARG_PDECL               /* Optional %extra_argument parameter */
){
  YYMINORTYPE yyminorunion;
  int yyact;            /* The parser action. */
  int yyendofinput;     /* True if we are at the end of input */
  int yyerrorhit = 0;   /* True if yymajor has invoked an error */
  yyParser *yypParser;  /* The parser */

  /* (re)initialize the parser, if necessary */
  yypParser = (yyParser*)yyp;
  if( yypParser->yyidx<0 ){
    if( yymajor==0 ) return;
    yypParser->yyidx = 0;
    yypParser->yyerrcnt = -1;
    yypParser->yystack[0].stateno = 0;
    yypParser->yystack[0].major = 0;
  }
  yyminorunion.yy0 = yyminor;
  yyendofinput = (yymajor==0);
  etl_parser_parseARG_STORE;

#ifndef NDEBUG
  if( yyTraceFILE ){
    fprintf(yyTraceFILE,"%sInput %s\n",yyTracePrompt,yyTokenName[yymajor]);
  }
#endif

  do{
    yyact = yy_find_shift_action(yypParser,yymajor);
    if( yyact<YYNSTATE ){
      yy_shift(yypParser,yyact,yymajor,&yyminorunion);
      yypParser->yyerrcnt--;
      if( yyendofinput && yypParser->yyidx>=0 ){
        yymajor = 0;
      }else{
        yymajor = YYNOCODE;
      }
    }else if( yyact < YYNSTATE + YYNRULE ){
      yy_reduce(yypParser,yyact-YYNSTATE);
    }else if( yyact == YY_ERROR_ACTION ){
      int yymx;
#ifndef NDEBUG
      if( yyTraceFILE ){
        fprintf(yyTraceFILE,"%sSyntax Error!\n",yyTracePrompt);
      }
#endif
#ifdef YYERRORSYMBOL
      /* A syntax error has occurred.
      ** The response to an error depends upon whether or not the
      ** grammar defines an error token "ERROR".  
      **
      ** This is what we do if the grammar does define ERROR:
      **
      **  * Call the %syntax_error function.
      **
      **  * Begin popping the stack until we enter a state where
      **    it is legal to shift the error symbol, then shift
      **    the error symbol.
      **
      **  * Set the error count to three.
      **
      **  * Begin accepting and shifting new tokens.  No new error
      **    processing will occur until three tokens have been
      **    shifted successfully.
      **
      */
      if( yypParser->yyerrcnt<0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yymx = yypParser->yystack[yypParser->yyidx].major;
      if( yymx==YYERRORSYMBOL || yyerrorhit ){
#ifndef NDEBUG
        if( yyTraceFILE ){
          fprintf(yyTraceFILE,"%sDiscard input token %s\n",
             yyTracePrompt,yyTokenName[yymajor]);
        }
#endif
        yy_destructor(yymajor,&yyminorunion);
        yymajor = YYNOCODE;
      }else{
         while(
          yypParser->yyidx >= 0 &&
          yymx != YYERRORSYMBOL &&
          (yyact = yy_find_shift_action(yypParser,YYERRORSYMBOL)) >= YYNSTATE
        ){
          yy_pop_parser_stack(yypParser);
        }
        if( yypParser->yyidx < 0 || yymajor==0 ){
          yy_destructor(yymajor,&yyminorunion);
          yy_parse_failed(yypParser);
          yymajor = YYNOCODE;
        }else if( yymx!=YYERRORSYMBOL ){
          YYMINORTYPE u2;
          u2.YYERRSYMDT = 0;
          yy_shift(yypParser,yyact,YYERRORSYMBOL,&u2);
        }
      }
      yypParser->yyerrcnt = 3;
      yyerrorhit = 1;
#else  /* YYERRORSYMBOL is not defined */
      /* This is what we do if the grammar does not define ERROR:
      **
      **  * Report an error message, and throw away the input token.
      **
      **  * If the input token is $, then fail the parse.
      **
      ** As before, subsequent error messages are suppressed until
      ** three input tokens have been successfully shifted.
      */
      if( yypParser->yyerrcnt<=0 ){
        yy_syntax_error(yypParser,yymajor,yyminorunion);
      }
      yypParser->yyerrcnt = 3;
      yy_destructor(yymajor,&yyminorunion);
      if( yyendofinput ){
        yy_parse_failed(yypParser);
      }
      yymajor = YYNOCODE;
#endif
    }else{
      yy_accept(yypParser);
      yymajor = YYNOCODE;
    }
  }while( yymajor!=YYNOCODE && yypParser->yyidx>=0 );
  return;
}
